#ifndef ARRAYITERATOR_H_
#define ARRAYITERATOR_H_

#include "Iterator.h"

class ArrayIterator : public Iterator
{
public:
    ArrayIterator(int arr[], int sz)
        : array(arr), size(sz), cursor(0) {}

    int  first()        { return array[0]; }
    int  next()         { return array[++cursor]; }
    int  current_item() { return array[cursor]; }
    bool is_done()      { return cursor >= size; }

private:
    int *array;
    int size;
    int cursor;
};

#endif /* ARRAYITERATOR_H_ */
