#include <iostream>
#include <iomanip>
#include "Iterator.h"
#include "ArrayIterator.h"
#include "VectorIterator.h"
using namespace std;

void print(Iterator &it);

int main()
{
    int a[] = {10, 20, 30, 40, 50};
    vector<int> v;

    v.push_back(100);
    v.push_back(200);
    v.push_back(300);

    ArrayIterator  ait(a, 5);
    VectorIterator vit(v);

    cout << "Array elements: ";
    print(ait);
    cout << endl;

    cout << "Vector elements:";
    print(vit);
    cout << endl;

    return 0;
}

void print(Iterator &it)
{
    int elmt = it.first();

    while (!it.is_done())
    {
        cout << setw(5) << elmt;
        elmt = it.next();
    }
}
