#ifndef VECTORITERATOR_H_
#define VECTORITERATOR_H_

#include <vector>
#include "Iterator.h"
using namespace std;

class VectorIterator : public Iterator
{
public:
    VectorIterator(vector<int> v) : vec(v), cursor(0) {}

    int  first()        { return vec[0]; }
    int  next()         { return vec[++cursor]; }
    int  current_item() { return vec[cursor]; }
    bool is_done()      { return cursor >= vec.size(); }

private:
    vector<int> vec;
    int cursor;
};

#endif /* VECTORITERATOR_H_ */
